/*jslint nomen: true, maxlen: 200, indent: 2*/
/*global rJS, console, window, document, RSVP*/

(function (window, document, rJS) {
  "use strict";

  rJS(window)
    .ready(function (g) {
      var
        element_list = g.element.querySelectorAll("[data-renderjs-configuration]"),
        len = element_list.length,
        key,
        value,
        i;
        // queue = new RSVP.Queue();

      // function setSetting(key, value) {
      //   queue.push(function () {
      //     return gadget.setSetting(key, value);
      //   });
      // }

      g.props = {
        json_schema_element: document.getElementById('json_schema'),
        json_schema_element_active: false
      };

      g.options = {
        schema_url: "",
        value:
          {
            "zdsddfr3434": { "dadasd": 34},
            "sla-dict": {"zzzz":[1,2,3]},
            "developer-list": ["0000000000","fsdfasdf111","fsadf222"],
            "zope-partition-dict": {
              "DDDdf": {"family":"fsdfsd","instance-count":1},
              "LLsd33fqq[//": {"family":"fsdfsdf33333"}
              },
            // "zodb":[{"storage-dict":{"dsdasd":""},"dasd":"","name":"czxc","mount-point":"czxc"}],
            "site-id":"fsdf"
          }
        // {"user-authorized-key": "AbocEgsom#"}
      };

      for (i = 0; i < len; i += 1) {
        key = element_list[i].getAttribute('data-renderjs-configuration');
        value = element_list[i].textContent;
        g.options[key] = value;
        // setSetting(key, value);
      }
      return g.getDeclaredGadget("form_view")
        .push(function (form_view) {
          g.props.form_view = form_view;
          return form_view.render(g.options);
        })
        .push(undefined, function (error) {
          console.error(error);
          throw error;
        });
    })
    .allowPublicAcquisition("notifyValid", function () {
      return;
    })
    .allowPublicAcquisition("notifyInvalid", function () {
      return;
    })
    .allowPublicAcquisition("notifyChange", function (arr, scope) {
      if (scope === "form_view") {
        return this.getDeclaredGadget("form_view")
          .push(function (g) {
            return g.getContent();
          })
          .push(function (ret) {
            document.getElementById("json_document_content").textContent =
              JSON.stringify(ret);
          });
      }
      return;
    })
    .onEvent("submit", function () {
      var g = this;
      return g.props.form_view.getContent()
        .push(function (data) {
          console.log(data);
        });
    });

}(window, document, rJS));